﻿function GameScreen() {
    this._inheritFrom = UiScreen;
    this._inheritFrom();

    this._player = null;
    this._enemies = null;
    this._inputActioned = false;

    this._isPaused = false;
    this._isGameOver = false;
    this._isCompleted = false;
    this._levNo = 0;

    this._parallax0 = 0;
    this._parallax1 = 1;
    this._parallax2 = 2;
    this._astroidLayer = 3;
    this._enemyLayer = 4;
    this._bulletLayer = 5;
    this._enemyBulletLayer = 6;
    this._bonusLayer = 7;
    this._playerLayer = 8;
    this._fxLayer = 9;
    this._guiLayer = 10;
    this._layerCount = 11;

    this._updateTick = 0;
    this._updateTickPart = 0;
    this._updateTickSmallPart = 0;
    this._bulletIndex = 0;
    this._astroidIndex = 0;
    this._ctrlDown = false;
    this._ctrldPos = null;
    this._ctrldRest = null;
    this._ctrlChanged = false;
    this._isFireDown = false;

    this._maxAsteroid = 1;
    this._maxBonus = 4;
    this._maxEnemy = 3;
    this._enemyAccuracy = 50;

    this._hpElement = null;
    this._scoreElement = null;
    this._wpElement = null;
    this._wpcElement = null;

    this._baseDispose = this._dispose;
    this._dispose = function () {
        this._baseDispose();

        this._player = null;
        this._hpElement = null;
        this._scoreElement = null;
        this._wpElement = null;
        this._wpcElement = null;
    }

    this._start = function () {
    }

    this._go = function (l) {
        this._levNo = l;
        this._hpElement = this._elements["hp"];
        this._scoreElement = this._elements["sc"];
        this._wpElement = this._elements["wp"];
        this._wpcElement = this._elements["wpc"];

        switch (l) {
            default:
                this._maxAsteroid = 20;
                this._maxBonus = 4;
                this._maxEnemy = 3;
                this._enemyAccuracy = 100;
                break;
        }

        this._player = this._createPlayer("p1", 0, 0, 0);
        this._setRestPoint();

        this._createAstroidBelt();

        this._pinCameraToPlayer();
        this._addHp(0);

        this._setWeapon("b1");

        var o = $('#ctrlbk').position();
        _ctrlPos = new Point2(o.left, o.top);
    }

    this._createPlayer = function (mo, x, y, i) {
        var m = _modelManager._addModelFromCache(mo, x, y);

        this._world._addObject(this._playerLayer, m);
        m._play("p1");

        m._isHuman = true;
        m._sourceTransformChanged(1, 1);
        m._index = i;
        m._indexPart = (i & 3);

        return m;
    }

    this._createAstroidBelt = function () {
        for (var i = 0; i < this._maxAsteroid; i++) {
            this._createRandomAsteroid();
        }
    }

    this._createRandomAsteroid = function () {
        var p = this._getRandomPosition();
        var t = ((Math.random() * 14) >> 0) + 1;

        this._createAstroid("a" + t, p._x, p._y);
    }

    this._createRandomEnemy = function () {
        if (this._world._layers[this._enemyLayer].length > this._maxEnemy) {
            return;
        }

        var t = ((Math.random() * 15) >> 0) + 1;

        if (t > 2) {
            return;
        }

        var p = this._getRandomPosition();
        this._createEnemy("em" + t, p._x, p._y);
    }

    this._createRandomBonus = function () {
        if (this._world._layers[this._bonusLayer].length > this._maxBonus) {
            return;
        }

        var t = ((Math.random() * 15) >> 0) + 1;

        if (t > 4) {
            return;
        }

        var p = this._getRandomPosition();
        this._createBonus("bn" + t, p._x, p._y);
    }

    this._getRandomPosition = function () {
        var p = null;

        while (p == null) {
            var x = (Math.random() * (AREA_MAX_X << 1)) + AREA_MIN_X;
            var y = (Math.random() * (AREA_MAX_Y << 1)) + AREA_MIN_Y;

            var d = Common_GetDistanceBetweenPoints(x, y, this._player._x, this._player._y);
            if (d > 100) {
                p = new Point2(x, y);
            }
        }

        return p;
    }

    this._createAstroid = function (mo, x, y) {
        var m = _modelManager._addModelFromCache(mo, x, y);
        m._sourceTransformChanged(1, 1);
        m._spin = Math.random() * 1;
        m._direction._x = 1 - (Math.random() * 2);
        m._direction._y = 1 - (Math.random() * 2);
        m._index = this._astroidIndex;
        m._indexPart = (m._index & 3);
        m._play("f1");

        this._world._addObject(this._astroidLayer, m);
        this._astroidIndex++;
    }

    this._createEnemy = function (mo, x, y) {
        var m = _modelManager._addModelFromCache(mo, x, y);
        m._sourceTransformChanged(1, 1);
        m._direction._x = 1 - (Math.random() * 2);
        m._direction._y = 1 - (Math.random() * 2);
        m._index = this._astroidIndex;
        m._indexPart = (m._index & 3);

        switch (mo) {
            case "em1":
                m._defense = 0.2;
                m._weapon = "b3";
                m._fireProbability = 0.05;
                break;
            case "em2":
                m._defense = 0.6;
                m._weapon = "b1";
                m._fireProbability = 0.07;
                break;
        }

        this._world._addObject(this._enemyLayer, m);
        this._astroidIndex++;
    }

    this._destroyAstroid = function (a) {
        var cl = new Array();
        var ox = 0;
        var oy = 0;

        switch (a._name) {
            case "a1":
                cl.push(4);
                cl.push(5);
                cl.push(6);
                ox = 200;
                oy = 150;
                this._createExp(a, "e2", ox, oy);
                break;
            case "a2":
                cl.push(8);
                cl.push(5);
                cl.push(6);
                ox = 200;
                oy = 150;
                this._createExp(a, "e2", ox, oy);
                break;
            case "a3":
                cl.push(8);
                cl.push(9);
                cl.push(7);
                ox = 200;
                oy = 150;
                this._createExp(a, "e2", ox, oy);
                break;
            case "a4":
                cl.push(10);
                cl.push(11);
                cl.push(12);
                ox = 150;
                oy = 125;
                this._createExp(a, "e2", ox, oy);
                break;
            case "a5":
                cl.push(13);
                cl.push(12);
                ox = 150;
                oy = 80;
                this._createExp(a, "e2", ox, oy);
                break;
            case "a6":
                cl.push(14);
                cl.push(15);
                ox = 120;
                oy = 120;
                this._createExp(a, "e2", ox, oy);
                break;
            case "a7":
                cl.push(13);
                cl.push(15);
                ox = 110;
                oy = 110;
                this._createExp(a, "e1", ox, oy);
                break;
            case "a8":
                cl.push(15);
                cl.push(14);
                ox = 90;
                oy = 90;
                this._createExp(a, "e1", ox, oy);
                break;
            case "a9":
                cl.push(15);
                cl.push(14);
                ox = 90;
                oy = 90;
                this._createExp(a, "e1", ox, oy);
                break;
            case "a10":
                cl.push(13);
                cl.push(15);
                ox = 90;
                oy = 90;
                this._createExp(a, "e1", ox, oy);
                break;
            case "a11":
                cl.push(14);
                cl.push(15);
                ox = 130;
                oy = 90;
                this._createExp(a, "e1", ox, oy);
                break;
            case "a12":
                cl.push(15);
                cl.push(14);
                ox = 80;
                oy = 140;
                this._createExp(a, "e1", ox, oy);
                break;
            case "a13":
                cl.push(15);
                cl.push(14);
                ox = 50;
                oy = 50;
                this._createExp(a, "e1", ox, oy);
                break;
            case "a14":
                ox = 15;
                oy = 15;
                this._createExp(a, "e1", ox, oy);
                break;
            case "a15":
                ox = 5;
                oy = 5;
                this._createExp(a, "e1", ox, oy);
                break;
        }

        for (var i = 0; i < cl.length; i++) {
            var x = a._x + ((ox >> 1) - (Math.random() * ox));
            var y = a._y + ((oy >> 1) - (Math.random() * oy));
            this._createAstroid("a" + cl[i], x, y);
        }

        var s = a._animations.length * 25;
        this._player._addScore(s);

        var r = 0;
        var l = this._world._layers[this._astroidLayer];

        for (var i = 0; i < l.length; i++) {
            if (!l[i]._hasDied) {
                r++;
            }
        }

        if (r == 0) {
            this._completed();
        }
    }

    this._unitDestroyed = function (o) {
        switch (o._name) {
            case "em1":
                this._player._addScore(1000);
                break;
            case "em2":
                this._player._addScore(500);
                break;
        }
    }

    this._addHp = function (v) {
        return this._player._addHp(v, 1);
    }

    this._baseResize = this._onResize;
    this._onResize = function () {
        if (this._baseResize()) {
        }
    }

    this._fireDown = function () {
        this._isFireDown = true;
        this._player._doFire();
    }

    this._fireUp = function () {
        this._isFireDown = false;
    }

    this._setRestPoint = function () {
        this._ctrldRest = new Point2((_ctrlDim._x - _ctrlDimD._x) >> 1, (_ctrlDim._y - _ctrlDimD._y) >> 1);
        this._ctrldPos = new Point2(this._ctrldRest._x, this._ctrldRest._y);
        this._ctrlChanged = true;
    }

    this._renderAndUpdate = function (t, x, y) {
        if ((t & 1) == 0) {
            if (this._isPaused) {
                return;
            }

            this._renderOnly(t, x, y);
        }
        else {
            if (this._isPaused) {
                return;
            }

            this._updateOnly(t, x, y);
            this._updateTick++;
            this._updateTickPart = (this._updateTick & 3);
            this._updateTickSmallPart = (this._updateTick & 1);
        }
    }

    this._renderOnly = function (t, x, y) {
        var w = this._world;
        var c = w._camera;

        w._fillBackground(_backContext1, "#000000");
        w._renderLayer(_backContext1, w._layers[this._parallax0], x, y);
        w._renderLayer(_backContext1, w._layers[this._parallax1], x, y);
        w._renderLayer(_backContext1, w._layers[this._parallax2], x, y);
        w._renderLayer(_backContext1, w._layers[this._bulletLayer], x, y);
        w._renderLayer(_backContext1, w._layers[this._enemyBulletLayer], x, y);
        w._renderLayer(_backContext1, w._layers[this._bonusLayer], x, y);
        w._renderLayer(_backContext1, w._layers[this._playerLayer], x, y);
        w._renderLayer(_backContext1, w._layers[this._enemyLayer], x, y);
        w._renderLayer(_backContext1, w._layers[this._astroidLayer], x, y);
        w._renderLayer(_backContext1, w._layers[this._fxLayer], x, y);
        w._renderLayer(_backContext1, w._layers[this._guiLayer], x, y);
    }

    this._updateOnly = function (t, x, y) {
        var w = this._world;
        var c = this._world._camera;

        w._updateLayer(_backContext1, w._layers[this._playerLayer], x, y);
        w._updateLayer(_backContext1, w._layers[this._bulletLayer], x, y);
        w._updateLayer(_backContext1, w._layers[this._enemyBulletLayer], x, y);
        w._updateLayer(_backContext1, w._layers[this._astroidLayer], x, y);
        w._updateLayer(_backContext1, w._layers[this._enemyLayer], x, y);
        w._updateLayer(_backContext1, w._layers[this._bonusLayer], x, y);
        w._updateLayer(_backContext1, w._layers[this._fxLayer], x, y);
        w._updateLayer(_backContext1, w._layers[this._guiLayer], x, y);

        if (!this._ctrlDown) {
            var dx = (this._ctrldRest._x - this._ctrldPos._x) * 0.5;
            var dy = (this._ctrldRest._y - this._ctrldPos._y) * 0.5;
            var adx = Math.abs(dx);
            var ady = Math.abs(dy);

            if (adx + ady <= 0) {
            }
            else if (adx + ady < 0.01) {
                this._ctrldPos = new Point2(this._ctrldRest._x, this._ctrldRest._y);
                this._ctrlChanged = true;
            }
            else {
                this._ctrldPos._x += dx;
                this._ctrldPos._y += dy;
                this._ctrlChanged = true;
            }
        }

        this._player._showFlame = this._ctrlDown;
        var d = Common_GetDistanceBetweenPoints(this._ctrldRest._x, this._ctrldRest._y, this._ctrldPos._x, this._ctrldPos._y);
        var a = Common_CalculateAngle(this._ctrldRest._x, this._ctrldRest._y, this._ctrldPos._x, this._ctrldPos._y);

        var p = new Point2(0, -1);
        p = Common_RotatePoint2(0, 1, MatrixUtility_DegToRad(a), 0, 0);

        var s = d * 0.005;
        this._player._direction._x = (this._player._direction._x * 0.99) + (-p._x * s);
        this._player._direction._y = (this._player._direction._y * 0.99) + (-p._y * s);

        if (this._ctrlChanged) {
            $('#ctrld').css('left', this._ctrldPos._x + 'px');
            $('#ctrld').css('top', this._ctrldPos._y + 'px');

            this._ctrlChanged = false;
        }

        this._pinCameraToPlayer();

        var h = (this._player._hp * 100) >> 0;
        this._hpElement._setText(padx(h + "", 2));
        this._scoreElement._setText(padx((this._player._score >> 0) + "", 6));

        this._createRandomBonus();
        this._createRandomEnemy();

        var x = this._world._width * _screenScale2;
        this._wpElement._x = x - 80;
        this._wpcElement._x = x - 60;
    }

    this._createExp = function (s, n, dx, dy) {
        var c = 6;

        switch (s._name) {
            case "p1":
                c = 6;
                break;
            case "a7":
            case "a8":
            case "a9":
                c = 4;
                break;
            case "a13":
            case "a12":
            case "a11":
            case "a10":
                c = 3;
                break;
            case "a14":
            case "a15":
                c = 1;
                break;
            default:
                c = 6;
                break;
        }
        if (c > 1) {
            for (var i = 0; i < c; i++) {
                var x = s._x + ((Math.random() * dx) - (dx >> 1));
                var y = s._y + ((Math.random() * dy) - (dy >> 1));
                var d = (Math.random() * 10) >> 0;

                if (c == 1) {
                    d = 0;
                }
                this._createSingleExplosion(n, x, y, d);
            }
        }
        else {
            this._createSingleExplosion(n, s._x, s._y);
        }
    }

    this._createSingleExplosion = function (n, x, y, d) {
        var m = _modelManager._addModelFromCache(n, x, y);
        m._sourceTransformChanged(1, 1);
        m._yInc = 0;
        m._delay = d;
        if (d > 0) {
            m._isVisible = false;
        }
        m._play("n", function () {
            m._completed = true;
        });

        this._world._addObject(this._fxLayer, m);
    }

    this._createBonus = function (mo, x, y) {
        var m = _modelManager._addModelFromCache(mo, x, y);
        m._sourceTransformChanged(1, 1);
        m._spin = Math.random() * 1;
        m._direction._x = 1 - (Math.random() * 2);
        m._direction._y = 1 - (Math.random() * 2);

        this._world._addObject(this._bonusLayer, m);
    }

    this._createBullet = function (t, s) {
        var xoff = 0;
        var yoff = 0;
        var sp = 1;
        var a = 0;

        if (s._isHuman) {
            a = s._getFireAngle();
        }
        else {
            var ha = this._enemyAccuracy * 0.5;

            var x = this._player._x + ((Math.random() * this._enemyAccuracy) - ha);
            var y = this._player._y + ((Math.random() * this._enemyAccuracy) - ha);
            a = Common_CalculateAngle(s._x, s._y, x, y);
        }

        var dir = Common_RotatePoint2(0, -1, MatrixUtility_DegToRad(a), 0, 0);
        var x = s._x + xoff;
        var y = s._y + yoff;

        switch (t) {
            case "b1":
                this._createBulletPart(t, x, y, dir, s);
                break;
            case "b2":
                this._createBulletPart(t, x, y, dir, s);
                break;
            case "b3":
                this._createBulletPart(t, x, y, dir, s);
                break;
            default:
                break;
        }
    }

    this._createBulletPart = function (t, x, y, dir, s) {
        var m = _modelManager._addModelFromCache(t, x, y);
        var pm = 5;

        switch (t) {
            case "b1":
                sp = 4;
                pm = 2;
                m._strength = -0.5;
                break;
            case "b2":
                sp = 3;
                pm = 1;
                m._strength = -0.9;
                break;
            case "b3":
                sp = 3;
                pm = 2;
                m._strength = -0.9;
                break;
            default:
                m._strength = -0.05;
                break;
        }

        m._sourceTransformChanged(1, 1);
        m._dirX = dir._x * 6;
        m._dirY = dir._y * 6;

        m._speed = sp;
        m._owner = s;
        m._index = this._bulletIndex;
        m._indexPart = (m._index & 1);
        m._move(pm);

        this._bulletIndex++;
        this._world._addObject(this._bulletLayer, m);
    }

    this._bonusCollected = function (o) {
        switch (o._name) {
            case "bn1":
                this._player._addHp(0.25, 1);
                break;
            case "bn2":
                this._player._setShield();
                break;
            case "bn3":
                this._setWeapon("b3");
                this._player._weaponCount += 15;
                this._updateWeaponCount();
                break;
            case "bn4":
                this._setWeapon("b2");
                this._player._weaponCount += 5;
                this._updateWeaponCount();
                break;
        }
    }

    this._setWeapon = function (w) {
        if (this._player._weapon != w) {
            this._player._weaponCount = 0;
        }

        this._player._weapon = w;
        this._wpElement._isVisible = true;
        this._wpcElement._isVisible = true;

        switch (w) {
            case "b1":
                this._wpElement._isVisible = false;
                this._wpcElement._isVisible = false;
                this._wpcElement._setText("");
                break;
            case "b2":
                this._wpElement._play(w);
                this._updateWeaponCount();
                break;
            case "b3":
                this._wpElement._play(w);
                this._updateWeaponCount();
                break;
        }
    }

    this._updateWeaponCount = function () {
        this._wpcElement._setText(this._player._weaponCount + "", 2);
    }

    this._gameover = function () {
        console.log("Gameover");
        var th = this;

        this._isGameOver = true;
        this._isCompleted = false;
        hideControls();

        setTimeout(function () {
            th._elements["gopop"]._setupLost(th._levNo, 0);
        }, 1000);
    }

    this._completed = function () {
        console.log("Completed");
        var th = this;
        hideControls();

        this._isGameOver = true;
        this._isCompleted = true;

        setTimeout(function () {
            th._elements["gopop"]._setupWon(th._levNo, th._player._hp);
        }, 1000);
    }

    this._createCameras = function () {
        var gc = this._world._camera._clone();
        gc._x = 0;
        gc._y = 0;

        this._world._layers[this._guiLayer]._camera = gc;

        this._world._layers[this._parallax0]._camera = this._world._camera._clone();
        this._world._layers[this._parallax1]._camera = this._world._camera._clone();
        this._world._layers[this._parallax2]._camera = this._world._camera._clone();
    }

    this._updateCameras = function () {
        this._pinCameraToPlayer();
    }

    this._pinCameraToPlayer = function () {
        if (this._player) {
            var ox = this._world._camera._x;
            var hw = (this._world._width >> 1) * _screenScale2;
            var hh = (this._world._height >> 1) * _screenScale2;
            this._world._camera._x = this._player._x - hw;
            this._world._camera._y = this._player._y - hh;

            var sw = 50;
            var sh = 50;

            if (this._world._camera._x < AREA_MIN_X - sw) {
                this._world._camera._x = AREA_MIN_X - sw;
            }
            else if (this._world._camera._x + (hw << 1) > AREA_MAX_X + sw) {
                this._world._camera._x = (AREA_MAX_X - (hw << 1)) + sw;
            }

            if (this._world._camera._y < AREA_MIN_Y - sh) {
                this._world._camera._y = AREA_MIN_Y - sh;
            }
            else if (this._world._camera._y + (hh << 1) > AREA_MAX_Y + sh) {
                this._world._camera._y = (AREA_MAX_Y - (hh << 1)) + sh;
            }

            this._updateOtherCameras();
        }
    }

    this._updateOtherCameras = function () {
        var hw = (this._world._width >> 1) * _screenScale2;
        var hh = (this._world._height >> 1) * _screenScale2;
        var px = 0;
        var py = 0;

        if (this._player) {
            px = this._player._x;
            py = this._player._y;
        }

        this._world._layers[this._parallax0]._camera._x = -hw;
        this._world._layers[this._parallax0]._camera._y = -hh;

        this._world._layers[this._parallax1]._camera._x = this._world._camera._x * 0.1;
        this._world._layers[this._parallax1]._camera._y = this._world._camera._y * 0.1;
        this._world._layers[this._parallax2]._camera._x = this._world._camera._x * 0.2;
        this._world._layers[this._parallax2]._camera._y = this._world._camera._y * 0.2;
    }

    this._inputDownProcess = function (x, y) {
        this._lastInputX = x;
        this._lastInputY = y;

        if (_mainPopupVisible) {
            return;
        }

        if (this._children) {
            for (var i = 0; i < this._children.length; i++) {
                this._children[i]._inputDownProcess(x, y);
            }
        }

        this._ctrlDown = false;

        if (!this._isGameOver) {
            if (x >= _ctrlPos._x && x < _ctrlPos._x + _ctrlDim._x && y >= _ctrlPos._y && y < _ctrlPos._y + _ctrlDim._y) {
                this._ctrlDown = true;
            }
            else {
                this._cPos(x, y);
                this._checkButtonPress(true);
            }

            this._inputDown = true;
            this._inputActioned = false;
        }

        return false;
    }

    this._inputMoveProcess = function (x, y) {
        if (_mainPopupVisible) {
            return;
        }

        if (this._ctrlDown && !this._isGameOver) {
            var ox = x - _ctrlPos._x;
            var oy = y - _ctrlPos._y;

            ox -= _ctrlDimD._x >> 1;
            oy -= _ctrlDimD._y >> 1;

            this._ctrlChanged = true;
            var a = Common_CalculateAngle(this._ctrldRest._x, this._ctrldRest._y, ox, oy);
            this._player._setRotate(a);

            var d = Common_GetDistanceBetweenPoints(this._ctrldRest._x, this._ctrldRest._y, ox, oy);
            if (d > 60) {
                var p = Common_RotatePoint2(0, -60, MatrixUtility_DegToRad(a), 0, 0);
                this._ctrldPos._x = this._ctrldRest._x + p._x;
                this._ctrldPos._y = this._ctrldRest._y + p._y;
            }
            else {
                this._ctrldPos._x = ox;
                this._ctrldPos._y = oy;
            }
        }

        return false;
    }

    this._inputUpProcess = function () {
        for (var i = 0; this._children != null && i < this._children.length; i++) {
            this._children[i]._inputUpProcess();
        }
        if (_mainPopupVisible) {
            return;
        }

        this._checkButtonPress(false);
        this._inputDown = false;

        if (this._ctrlDown) {
            this._ctrlDown = false;
        }

        if (!this._inputActioned) {
            if (!this._isEditor) {
            }
            else {
                this._clearSelectedUnit();
            }
        }
    }

    this._buttonPressed = function (o) {
        switch (o._name) {
            case "pauseb":
                this._isPaused = true;
                break;
        }
    }

    this._lifeLost = function (rs) {
        if (!this._player._hasDied) {
            this._addLife(-1);

            if (_playerProfile._lives <= 0) {
                this._player._hasDied = true;
                this._gameover();
                return true;
            }
            else {
                if (rs) {
                    this._ticksTilRespawn = 40;
                }
            }
        }
        return false;
    }

    this._isYOverHud = function (y) {
        var pt = $('#editorHud').offset();

        if (y > pt.top) {
            return true;
        }

        return false;
    }

    this._showGameOver2 = function () {
        this._elements["go2pop"]._setupGameover();
    }
}