﻿var pi2 = Math.PI * 2;

/* Math stuff */
function Common_CalculateAngle(p1x, p1y, p2x, p2y) {
    var ACoords = new Array();
    var result = 0;

    ACoords.push(p2y - p1y);
    ACoords.push(p2x - p1x);

    if (ACoords[0] == 0) {
        ACoords[0] = 0.00000001;
    }
    if (ACoords[1] == 0) {
        ACoords[1] = 0.00000001;
    }

    result = Math.atan(ACoords[0] / ACoords[1]) + MatrixUtility_HalfPI;

    if (ACoords[1] < 0) {
        result = result + Math.PI;
    }

    return MatrixUtility_RadToDeg(result);
}

function Common_GetDistanceBetweenPoints(x1, y1, x2, y2) {
    return Math.sqrt(Math.pow(x2 - x1, 2) + Math.pow(y2 - y1, 2));
}

function Common_GetDistanceBetweenPoints2(p1, p2) {
    return Math.sqrt(Math.pow(p2._x - p1._x, 2) + Math.pow(p2._y - p1._y, 2));
}

function Common_GetDirectionBetweenPoints(p1, p2) {
    var offsetX = p2._x - p1._x;
    var offsetY = p2._y - p1._y;
    var dist = Math.sqrt(Math.pow(offsetX, 2) + Math.pow(offsetY, 2));

    return new Vector2(offsetX / dist, offsetY / dist);
}

function Common_CalculateDifferenceBetweenAngles(a1, a2) {
    var d = a2 - a1;

    while (d < -180) {
        d += 360;
    }
    while (d > 180) {
        d -= 360;
    }

    return d;
}

function Common_GetDistanceValue(x1, y1, x2, y2) {
    var xOffset = x2 - x1;
    var yOffset = y2 - y1;

    if (xOffset < 0) {
        xOffset = -xOffset;
    }
    if (yOffset < 0) {
        yOffset = -yOffset;
    }

    if (xOffset >= yOffset) {
        return (xOffset * 10) + (yOffset * 14);
    }
    else {
        return (yOffset * 10) + (xOffset * 14);
    }
}

function Common_RotatePoint(p, theta) {
    var rx = Math.cos(theta) * p._x - Math.sin(theta) * p._y;
    var ry = Math.sin(theta) * p._x + Math.cos(theta) * p._y;
    var result = new Point2(rx, ry);

    return result;
}

function Common_RotatePoint2(px, py, theta, ox, oy) {
    var rx = Math.cos(theta) * px - Math.sin(theta) * py;
    var ry = Math.sin(theta) * px + Math.cos(theta) * py;
    var result = new Point2(0, 0);

    result._x = ox + rx;
    result._y = oy + ry;

    return result;
}

function Common_RotatePoint3(x, y, theta) {
    var rx = Math.cos(theta) * x - Math.sin(theta) * y;
    var ry = Math.sin(theta) * x + Math.cos(theta) * y;
    var result = new Point2(rx, ry);

    return result;
}

function Common_RotateVector2(px, py, theta, ox, oy) {
    var rx = Math.cos(theta) * px - Math.sin(theta) * py;
    var ry = Math.sin(theta) * px + Math.cos(theta) * py;
    var result = new Vector2();

    result._x = ox + rx;
    result._y = oy + ry;

    return result;
}

function Common_RotatePoint2AroundOrigin(px, py, theta, ox, oy) {
    px -= ox;
    py -= oy;
    var rx = Math.cos(theta) * px - Math.sin(theta) * py;
    var ry = Math.sin(theta) * px + Math.cos(theta) * py;
    var result = new Point2(0, 0);

    result._x = ox + rx;
    result._y = oy + ry;

    return result;
}

function Common_DeltaXYFromAngle(d, a) {
    var xx,yy;

    xx = (d* Math.cos (a * Math.PI / 180));
    yy = (d* Math.sin (a * Math.PI / 180));

    return new Point2(yy, xx);
}

function normalizeAngle(angle) {
    var newRotation = angle;

    while (newRotation < 0 || newRotation >= 360) {
        if (newRotation < 0) {
            newRotation = 360.0 + newRotation;
        }
        else if (newRotation >= 360.0) {
            newRotation = newRotation - 360.0;
        }
    }

    return isNaN(newRotation) ? 0 : newRotation;
}

function normalizeAngle2(angle) {
    angle = angle % 360;

    if (angle < 0) {
        angle += 360;
    }

    return angle;
}

function isPointInsidePolygon(offsetX, offsetY, poly, ps) {
    var i, j = 0;
    var result = false;
    var p = new Point2(ps._x - offsetX, ps._y - offsetY);
    //var c = _view._world._camera;


    for (i = 0, j = poly.length - 1; i < poly.length; j = i++) {
        /*var x = (poly[i]._x + offsetX) - c._x;
        var y = (poly[i]._y + offsetY) - c._y;
        _view._world._drawPoint(backContext, x, y);*/

        if (((poly[i]._y > p._y) != (poly[j]._y > p._y)) && (p._x < (poly[j]._x - poly[i]._x) * (p._y - poly[i]._y) / (poly[j]._y - poly[i]._y) + poly[i]._x)) {
            result = !result;
        }
    }
    return result;
}

function doesLineIntersectPolygon(poly, line) {
    var i;

    for (i = 0; i < poly._transformedPoints.length - 1; i++) {
        var intersect = lineIntersect2(poly._x + poly._transformedPoints[i]._x, poly._y + poly._transformedPoints[i]._y, poly._x + poly._transformedPoints[i + 1]._x, poly._y + poly._transformedPoints[i + 1]._y, line._x + line._transformedPoints[0]._x, line._y + line._transformedPoints[0]._y, line._x + line._transformedPoints[1]._x, line._y + line._transformedPoints[1]._y);
        if (intersect) {
            return intersect;
        }
    }

    return null;
}

function doesLineIntersectPolygonPointList(poly, line) {
    var i;

    for (i = 0; i < poly.length - 1; i++) {
        var intersect = lineIntersect2(poly[i]._x, poly[i]._y, poly[i + 1]._x, poly[i + 1]._y, line[0]._x, line[0]._y, line[1]._x, line[1]._y);
        if (intersect) {
            return intersect;
        }
    }

    return null;
}

function doesLineIntersectPolygonPointList2(poly, line, px, py) {
    var i;

    for (i = 0; i < poly.length - 1; i++) {
        var intersect = lineIntersect2(px + poly[i]._x, py + poly[i]._y, px + poly[i + 1]._x, py + poly[i + 1]._y, line[0]._x, line[0]._y, line[1]._x, line[1]._y);
        if (intersect) {
            return intersect;
        }
    }

    return null;
}

function lineIntersect2(v1x, v1y, v2x, v2y, v3x, v3y, v4x, v4y) {
    var tolerance = 0.000001;

    var a = Det2(v1x - v2x, v1y - v2y, v3x - v4x, v3y - v4y);
    if (Math.abs(a) < 1.401298E-45) {
        return null; // Lines are parallel
    }

    var d1 = Det2(v1x, v1y, v2x, v2y);
    var d2 = Det2(v3x, v3y, v4x, v4y);
    var x = Det2(d1, v1x - v2x, d2, v3x - v4x) / a;
    var y = Det2(d1, v1y - v2y, d2, v3y - v4y) / a;

    if (x < Math.min(v1x, v2x) - tolerance || x > Math.max(v1x, v2x) + tolerance) return null;
    if (y < Math.min(v1y, v2y) - tolerance || y > Math.max(v1y, v2y) + tolerance) return null;
    if (x < Math.min(v3x, v4x) - tolerance || x > Math.max(v3x, v4x) + tolerance) return null;
    if (y < Math.min(v3y, v4y) - tolerance || y > Math.max(v3y, v4y) + tolerance) return null;

    var result = new Point2(0, 0);
    result._x = x;
    result._y = y;
    return result;
}

function Det2(x1, x2, y1, y2) {
    return (x1 * y2 - y1 * x2);
}

/* Matrix Utility */
var MatrixUtility_HalfPI = Math.PI * 0.5;
var MatrixUtility_PI180 = 180 / Math.PI;

function MatrixUtility_RadToDeg(r) {
    return MatrixUtility_PI180 * r;
}

function MatrixUtility_DegToRad(deg) {
    return deg * 0.0174532925199432957;
}

function Vector2(x, y) {
    this._x = x;
    this._y = y;

    this._clone = function () {
        return new Vector2(this._x, this._y);
    }

    this._getMagnitude = function () {
        return Math.sqrt(this._x * this._x + this._y * this._y);
    }

    this._normalize = function () {
        var fmagnitude = this._getMagnitude();
        this._x = this._x / fmagnitude;
        this._y = this._y / fmagnitude;
    }

    this._dotProduct = function (v) {
        return this._x * v._x + this._y * v._y;
    }

    this._negative = function () {
        return new Vector2(-this._x, -this._y);
    }

    this._subNew = function (b) {
        return new Vector2(this._x - b._x, this._y - b._y);
    }

    this._addNew = function (b) {
        return new Vector2(this._x + b._x, this._y + b._y);
    }

    this._multiplyNew = function (m) {
        return new Vector2(this._x * m, this._y * m);
    }
}

function Point2(x, y) {
    this._x = x;
    this._y = y;

    this._dotProduct = function (v) {
        return this._x * v._x + this._y * v._y;
    }

    this._subNew = function (b) {
        return new Point2(this._x - b._x, this._y - b._y);
    }
}

function Size2(width, height) {
    this._width = width;
    this._height = height;
}

function Rect2(x, y, w, h) {
    this._x = x;
    this._y = y;
    this._width = w;
    this._height = h;
}