﻿function UiScreen() {
    this._inheritFrom = BaseView;
    this._inheritFrom();

    this._isEditor = false;
    this._bkgLayer = 0;
    this._buttonLayer = 1;
    this._layerCount = 2;

    this._renderAndUpdate = function (t, x, y) {
        var wd = this._world;
        var ctx = _backContext1;

        wd._renderAndUpdateLayer(ctx, wd._layers[this._bkgLayer], x, y);
        wd._renderAndUpdateLayer(ctx, wd._layers[this._buttonLayer], x, y);
    }

    this._inputDownProcess = function (x, y) {
        if (this._isVisible) {
            this._lastInputX = x;
            this._lastInputY = y;

            this._cPos(x, y);
            this._checkButtonPress(true);
            this._inputDown = true;

            if (this._children) {
                for (var i = 0; i < this._children.length; i++) {
                    this._children[i]._inputDownProcess(x, y);
                }
            }
        }
        return false;
    }

    this._inputMoveProcess = function (x, y) {
        return false;
    }

    this._inputUpProcess = function () {
        if (this._isVisible) {
            if (this._inputDown) {
                this._inputDown = false;
                this._checkButtonPress(false);
            }

            if (this._children) {
                for (var i = 0; i < this._children.length; i++) {
                    this._children[i]._inputUpProcess();
                }
            }
        }
    }

    this._checkButtonPress = function (d) {
        if (this._world) {
            var i = 0;
            var l = this._world._layers[this._buttonLayer];
            var b = false;

            for (i = 0; i < l.length && !b; i++) {
                if (l[i]._isButton && !l[i]._isDisabled) {
                    if (l[i]._hitTest(this._world._camera, this._evX, this._evY)) {
                        if (d) {
                            l[i]._inputDown();
                        }
                        else if (l[i]._isPressed) {
                            b = true;
                            this._buttonPressed(l[i]);
                            break;
                        }
                    }
                }
            }
        }
    }

    this._resetUi = function () {
        var l = this._world._layers[this._buttonLayer];

        for (i = 0; i < l.length; i++) {
            if (l[i]._isButton) {
                l[i]._reset();
            }
        }
    }

    this._buttonPressed = function (o) {
        console.log("Button pressed:" + o._name);
    }

    this._updateCameras = function () {
        var hw = (this._world._width >> 1) * _screenScale2;
        var hh = (this._world._height >> 1) * _screenScale2;
        this._world._camera._x = -hw;
        this._world._camera._y = -hh;
    }
}

function LoaderScreen() {
    this._inheritFrom = BaseView;
    this._inheritFrom();

    this._bkgLayer = 0;
    this._layerCount = 1;

    this._initLoaded = false;
    this._bar = null;

    this._baseDispose = this._dispose;
    this._dispose = function () {
        this._baseDispose();

        this._bar = null;
    }

    this._start = function () {
        this._bar = this._elements["bar"];

        var th = this;
        var img = new Object();
        var mds = new Array();
        var s = $(_mainXml).find('screens scr[id="home"]');
        var c = this._findAssets(s, mds, img);

        //return;

        if (c > 0) {
            _imageManager._loadBatch(img, function () {
                th._initLoaded = true;
                showFront();
            });
        }
        else {
            showFront();
        }

        _setXfs(this._elements["sgl"], "");
    }

    this._renderAndUpdate = function (t, x, y) {
        var wd = this._world;
        var ctx = _backContext1;

        wd._renderAndUpdateLayer(ctx, wd._layers[this._bkgLayer], x, y);

        if (!this._initLoaded) {
            var cr = _mainImageCountRemaining;

            if (cr == 0) {
                cr = _mainImageLoadCount;
            }

            var p = (((_mainImageLoadCount - cr) / _mainImageLoadCount) * 1);
            this._bar._target = p;
        }
    }
}

function HomeScreen() {
    this._inheritFrom = UiScreen;
    this._inheritFrom();

    this._start = function () {
        _setXfs(this._elements["sgl"], "");
        //this._elements["pot"]._moveTo(0, 0, 0.25, false, null);
    }

    this._renderAndUpdate = function (t, x, y) {
        var wd = this._world;
        var ctx = _backContext1;

        wd._fillBackground(ctx, '#000000');
        wd._renderAndUpdateLayer(ctx, wd._layers[this._bkgLayer], x, y);
        wd._renderAndUpdateLayer(ctx, wd._layers[this._buttonLayer], x, y);
    }

    this._buttonPressed = function (o) {
        console.log(o._name);

        switch (o._name) {
            case "ply":
                mapSelect(1);
                break;
            case "fb":
                fbFeedMessage = langGameText[2];
                fbShare();
                break;
        }
    }
}

function LevSelScreen() {
    this._inheritFrom = UiScreen;
    this._inheritFrom();

    this._start = function () {
        var y = -50;
        var gx = 100;
        var gy = 110;
        var l = 1;

        var i = 0;
        var x = -200;

        for (a = 0; a < 5; a++) {
            this._createLevSelectButton(l, x + (gx * a), y + (gy * i));
            l++;
        }

        i = 1;
        for (a = 0; a < 4; a++) {
            this._createLevSelectButton(l, x + (gx * a), y + (gy * i));
            l++;
        }
    }

    this._createLevSelectButton = function (l, x, y) {
        var p = getLevD(l);
        var d = false;

        if (l > 1) {
            var pl = getLevD(l - 1);
            d = (pl == 0);
        }

        if (d) {
            m = this._getModelInstance("locked", x, y);
        }
        else {
            m = this._getModelInstance("blank", x, y);
        }

        m._sourceTransformChanged(_screenScale, _screenScale);
        m._ref = l + '';
        this._world._addObject(1, m);

        if (!d) {
            m = this._getModelInstance("text2", x, y - 15);
            m._sourceTransformChanged(_screenScale, _screenScale);
            this._world._addObject(1, m);
            m._setText(l + "");

            if (l >= 10) {
                m._x -= 8;
            }

            m = this._getModelInstance("s3", x, y + 22);
            m._sourceTransformChanged(_screenScale, _screenScale);
            this._world._addObject(1, m);

            m._play("f" + p);
        }
    }

    this._renderAndUpdate = function (t, x, y) {
        var wd = this._world;
        var ctx = _backContext1;

        wd._renderAndUpdateLayer(ctx, wd._layers[this._bkgLayer], x, y);
        wd._renderAndUpdateLayer(ctx, wd._layers[this._buttonLayer], x, y);
    }

    this._buttonPressed = function (o) {
        console.log(o._name);

        switch (o._name) {
            case "blank":
                mapSelect(o._ref >> 0);
                break;
            case "blueB":
                showFront();
                break;
        }
    }
}

function PauseScreen() {
    this._inheritFrom = UiScreen;
    this._inheritFrom();

    this._show = function () {
        this._isVisible = true;
        this._moveTo(0, 0, 0.25, false, null);
        this._resetUi();
    }

    this._hide = function () {
        var th = this;

        this._moveTo(600, 0, 0.25, false, function () {
            th._isVisible = false;
        });
    }

    this._renderAndUpdate = function (t, x, y) {
        var wd = this._world;
        var ctx = _backContext;

        this._updateCameras();

        wd._renderAndUpdateLayer(ctx, wd._layers[this._bkgLayer], x, y);
        wd._renderAndUpdateLayer(ctx, wd._layers[this._buttonLayer], x, y);

        if (!this._updateMoveable()) {
            this._isVisible = false;
        }
    }

    this._updateCameras = function () {
        if (this._parent) {
            this._world._camera._x = this._parent._world._camera._x;
            this._world._camera._y = this._parent._world._camera._y;
        }
    }

    this._buttonPressed = function (o) {
        switch (o._name) {
            case "pauseclose":
            case "resume":
                this._hide();
                this._parent._isPaused = false;
                break;
            case "restart":
                mapSelect(this._parent._levNo);
                break;
            case "menu":
                showFront();
                break;
        }
    }
}

function GameOverScreen() {
    this._inheritFrom = UiScreen;
    this._inheritFrom();

    this._setupLost = function (l, s) {
        this._elements["vic"]._isVisible = false;
        this._elements["yd"]._isVisible = true;

        this._show();
    }

    this._setupWon = function (l, s) {
        this._elements["vic"]._isVisible = true;
        this._elements["yd"]._isVisible = false;

        this._show();
    }

    this._setupSnappy = function () {
        if (_vlx.isUserGuest()) {
            this._elements["ps"]._isVisible = true;
            _setXfs(this._elements["ps"], "");
        }
        else {
            this._elements["ps"]._isVisible = false;
            _clearXfs();
        }
    }

    this._show = function () {
        this._resetUi();

        this._elements["score"]._setText(padx(this._parent._player._score, 6));

        if (!_vlx.isUserGuest()) {
            saveHighscore(1, this._parent._player._score);
        }

        this._isVisible = true;
        this._moveTo(0, 0, 0.25, false, null);
    }

    this._renderAndUpdate = function (t, x, y) {
        var wd = this._world;
        var ctx = _backContext1;

        this._updateCameras();
        wd._renderAndUpdateLayer(ctx, wd._layers[this._bkgLayer], x, y);
        wd._renderAndUpdateLayer(ctx, wd._layers[this._buttonLayer], x, y);

        if (!this._updateMoveable()) {
            this._isVisible = false;
            _clearXfs();
        }
    }

    this._buttonPressed = function (o) {
        switch (o._name) {
            case "rty":
                /*showEol(function () {
                    showMap();
                });*/
                mapSelect(1);
                break;
            case "nxt":
                this._isVisible = false;
                this._parent._showGameOver2();
                break;
            case "mnu":
                showFront();
                break;
            case "fb":
                fbShare();
                break;
        }
    }
}

function GameOverScreen2() {
    this._inheritFrom = UiScreen;
    this._inheritFrom();

    this._setupGameover = function (l, s) {
        this._elements["score"]._setText(padx(this._parent._player._score, 6));

        this._setupSnappy();
        this._show();
    }

    this._setupSnappy = function () {
        if (_vlx.isUserGuest()) {
            this._elements["login"]._isVisible = true;
            this._elements["loggedin"]._isVisible = false;

            _setXfs(this._elements["login"], "", this._world._camera);
        }
        else {
            this._elements["login"]._isVisible = false;
            this._elements["loggedin"]._isVisible = true;
            _clearXfs();
        }
    }

    this._show = function () {
        this._resetUi();

        this._isVisible = true;
    }

    this._buttonPressed = function (o) {
        

        switch (o._name) {
            case "nxt":
                showFront();
                break;
            case "next":
                fbShare();
                break;
        }
    }
}