﻿function getDevice() {
    var d = "Web";
    var ua = navigator.userAgent;

    if (ua.match(/iPad/i) != null) {
        d = "iPad";
    }
    else if (ua.match(/iPod/i) != null) {
        d = "iPod";
    }
    else if (ua.match(/iPhone/i) != null) {
        d = "iPhone";
    }
    else if (ua.match(/Android/i) != null) {
        d = "Android";
    }
    else if (ua.match(/IEMobile/i) != null) {
        d = "IEMobile";
    }
    else if (/Kindle/i.test(ua) || /Silk/i.test(ua) || /KFTT/i.test(ua) || /KFOT/i.test(ua) || /KFJWA/i.test(ua) || /KFJWI/i.test(ua) || /KFSOWI/i.test(ua) || /KFTHWA/i.test(ua) || /KFTHWI/i.test(ua) || /KFAPWA/i.test(ua) || /KFAPWI/i.test(ua)) {
        d = "Kindle";
    }
    else if (/webOS|BlackBerry|Opera Mini/i.test(ua)) {
        d = "OtherTouch";
    }

    return d;
}

function drawText(s, a) {
    backContext.save();
    backContext.globalAlpha = a;
    backContext.fillStyle = "#ffffff";
    var fs = (40 * world._camera._scaleX) >> 0;
    backContext.font = fs + "px Arial";

    var td = backContext.measureText(s);
    var x = (world._width - td.width) >> 1;
    var y = (world._height >> 1) - 10;

    backContext.shadowColor = "rgba(0,0,0,0.4)";
    backContext.shadowBlur = 8;
    backContext.shadowOffsetX = 1;
    backContext.shadowOffsetY = 1;
    backContext.fillText(s, x, y);
    backContext.globalAlpha = 1;
    backContext.restore();
}

function padx(n, l) {

    var s = '' + n;
    while (s.length < l) {
        s = '0' + s;
    }

    return s;
}

function addImageSet(images, baseName, count, ext) {
    var i;
    var tmp;

    if (ext == null) {
        ext = "png";
    }

    for (i = 1; i <= count; i++) {
        tmp = baseName + "_" + i;
        images[tmp] = tmp + "." + ext;
    }
}

function indexOfArray(a, o) {
    for (var i = 0; i < a.length; i++) {
        if (a[i] == o) {
            return i;
        }
    }

    return -1;
}

function CsvToIntArray(c) {
    var a = new Array();

    var s = c.split(',');

    for (var i = 0; i < s.length; i++) {
        a.push(s[i] >> 0);
    }

    return a;
}

function FormatMineralString(v, n) {
    if (v < 0 || n) {
        if (v < 0) {
            v = -v;
        }
        return "<strong class='negative'>-" + Math.round(v) + "</strong>";
    }
    else {
        return "<strong class='positive'>+" + Math.round(v) + "</strong>";
    }
}

function CollisionDetector() {
    this._min = 0;
    this._max = 0;

    this._polygonCollision = function (polygonA, polygonB, velocity) {
        var result = new PolygonCollisionResult();
        result._intersect = true;
        result._willIntersect = true;

        var edgeCountA = polygonA._edges.length;
        var edgeCountB = polygonB._edges.length;
        var minIntervalDistance = Number.POSITIVE_INFINITY;
        var translationAxis = new Vector2();
        var edge = null;

        for (var edgeIndex = 0; edgeIndex < edgeCountA + edgeCountB; edgeIndex++) {
            if (edgeIndex < edgeCountA) {
                edge = polygonA._edges[edgeIndex];
            } else {
                edge = polygonB._edges[edgeIndex - edgeCountA];
            }

            var axis = new Vector2(-edge._y, edge._x);
            axis._normalize();

            // Find the projection of the polygon on the current axis
            var minA = 0;
            var minB = 0;
            var maxA = 0;
            var maxB = 0;
            this._projectPolygon(axis, polygonA);
            minA = this._min;
            maxA = this._max;
            this._projectPolygon(axis, polygonB);
            minB = this._min;
            maxB = this._max;

            // Check if the polygon projections are currentlty intersecting
            if (this._intervalDistance(minA, maxA, minB, maxB) > 0) {
                result._intersect = false;
            }

            // ===== 2. Now find if the polygons *will* intersect =====

            // Project the velocity on the current axis
            var velocityProjection = axis._dotProduct(velocity);

            // Get the projection of polygon A during the movement
            if (velocityProjection < 0) {
                minA += velocityProjection;
            } else {
                maxA += velocityProjection;
            }

            // Do the same test as above for the new projection
            var intervalDistance = this._intervalDistance(minA, maxA, minB, maxB);
            if (intervalDistance > 0) {
                result._willIntersect = false;
            }

            // If the polygons are not intersecting and won't intersect, exit the loop
            if (!result._intersect && !result._willIntersect) {
                break;
            }

            // Check if the current interval distance is the minimum one. If so store
            // the interval distance and the current distance.
            // This will be used to calculate the minimum translation vector
            intervalDistance = Math.abs(intervalDistance);
            if (intervalDistance < minIntervalDistance) {
                minIntervalDistance = intervalDistance;
                translationAxis = axis;

                var d = polygonA._getCenter()._subNew(polygonB._getCenter());
                if (d._dotProduct(translationAxis) < 0) {
                    translationAxis = translationAxis._negative();
                }
            }
        }

        // The minimum translation vector can be used to push the polygons appart.
        // First moves the polygons by their velocity
        // then move polygonA by MinimumTranslationVector.
        if (result._willIntersect) {
            result._minimumTranslationVector = translationAxis._multiplyNew(minIntervalDistance);
        }

        return result;
    }

    this._intervalDistance = function (minA, maxA, minB, maxB) {
        if (minA < minB) {
            return minB - maxA;
        } else {
            return minA - maxB;
        }
    }

    this._projectPolygon = function (axis, poly) {
        var d = axis._dotProduct(poly._transformedPoints[0]);
        this._min = d;
        this._max = d;
        for (var i = 0; i < poly._transformedPoints.length; i++) {
            d = poly._transformedPoints[i]._dotProduct(axis);
            if (d < this._min) {
                this._min = d;
            } else {
                if (d > this._max) {
                    this._max = d;
                }
            }
        }
    }
}

function PolygonCollisionResult() {
    this._willIntersect = false;
    this._intersect = false;
    this._minimumTranslationVector = null;
}

function LoadModelImages(x, cb) {
    var images = new Object();
    var c = 0;

    $(x).find('brush[t="image"]').each(function () {
        var n = $(this).attr('src');
        var f = $(this).attr('f');
        if (f == null) {
            f = "png";
        }
        images[n] = n + "." + f;
        c++;
    });

    $(x).find('f[type="bmp"], part[s^="img/"]').each(function () {
        var n = $(this).attr('s');
        var f = $(this).attr('f');
        if (f == null) {
            f = "png";
        }

        images[n] = n + "." + f;
        c++;
    });

    if (c > 0) {
        imageManager._loadBatch(images, function () {
            cb();
        });
    }
    else {
        cb();
    }
}

function ApplyAttributes(o, e) {
    var at = e.attr();
    for (var i = 0; i < at.length; i++) {
        var n = at[i];
        var ip = false;

        if (n.indexOf('_') == 0) {
            ip = true;
        }
        else {
            if (n.indexOf('f') == 0) {
                var s = n.replace('f', '');
                if (isNormalInteger(s)) {
                    ip = true;
                }
            }
        }

        if (ip) {
            var v = e.attr(n);

            if (v == "true" || v == "false") {
                eval("o." + n + " = " + v + ";");
            }
            else if (isNaN(v)) {
                eval("o." + n + " = '" + v + "';");
            }
            else {
                eval("o." + n + " = " + v + ";");
            }
        }
    }
}

function isNormalInteger(str) {
    var n = Number(str);
    return String(n) === str && n >= 0;
}